;Macro para fazer escada espiral.
;Macro realizada pela aluna Ana Clara Rodrigues, da turma B do 3 ano.
;Sistemas de representacao digital em arquitetura lecionada pelo professor Luis Romao
;Mestrado Integrado em Arquitetura - Faculdade de Arquitetura 

(defun c:spiralstair3D ( )
   (setq zcmd (getvar "cmdecho")
         zblp (getvar "blipmode")
         zosm (getvar "osmode")
   )
   (setvar "cmdecho" 0)
   (initget 1)
   (setq cn  (getpoint "\nCentro:")) 
   (initget 1)
   (setq ag0 (getangle cn "\nAngulo de Rotacao do primeiro passo:"))
   (initget 7)
   (setq r1  (getdist cn "\nRaio Interno:"))
   (initget 7)
   (setq r2  (getdist cn "\nOuter radius:"))
   (initget 3)
   (setq ag  (getreal "\nAngulo entre o primeiro e ultimo passo:"))
   (initget 3)
   (setq ht  (getreal "\nAltura da Escada [+ up][- down]:"))
   (initget 7)
   (setq nr  (getint "\nNumero de degraus:")
         ag (* pi (/ ag 180.0))
         rase (/ ht nr)
         dag  (/ ag nr)
         dht  (/ ht (1+ nr))
         ag1  (- ag0 dag)
         tyn 8
   )
   (setvar "osmode" 0)
   (setvar "blipmode" 0)
   (initget 1 "A B")
   (setq ty (getkword "\nEscada Espiral <B>:"))
   (initget 5)
   (setq rw (getreal "\nLargura do corrimao"))
   (initget 5)
   (setq rh (getreal "\nAltura do corrimao:"))
   (initget 1)
   (repeat (+ nr 1)
     (setq ag1 (+ ag1 dag)
           p1 (polar cn ag1 r1)
           p2 (polar cn ag1 r2)
           p3 (sp p1 dht)
           p4 (sp p2 dht)
     )
     (if (minusp ht)
         (setq pa (sp p1 (* 2 dht))         
               pb (sp p2 (* 2 dht))
         )
         (setq pa (sp p1 (* -1 dht))
               pb (sp p2 (* -1 dht))
         )
     )
     (if (and (equal ag1 ag0 0.001)(null (minusp ht)))
         (setq pa p1 pb p2)
     )
     (if (and (equal ag1 (+ ag0 ag) 0.001)(minusp ht))
         (setq pa (sp p1 dht) 
               pb (sp p2 dht)
     ))
     (setq b1 (sp p1 rh)
           b2 (polar b1 ag1 rw)
           b31 (polar p1 ag1 rw)
           b41 (polar cn ag1 (- r2 rw))
           b5 (sp b41 rh)
           b6 (polar b5 ag1 rw)
           b32 (sp b31 dht)
           b42 (sp b41 dht)
     )
     (if (= ty "B")
         (setq plist (append plist (list pa b1 b2 b31 b41 b5 b6 pb
                                         pa b1 b2 b32 b42 b5 b6 pb))
         )
     )
     (setq cn (list (car cn)(cadr cn)(+ (caddr cn) dht)))
   )
   (setq nr (length plist))
   (command "3dmesh" (/ nr tyn) tyn)
   (repeat nr
      (command (car plist))
      (setq plist (cdr plist))
   )
   (command "")
   (spstnc)
   (if lista
       (progn (setq nr (length lista))
              (command "3dmesh" (/ nr 4) "4")
              (repeat nr (command (car lista))
                         (setq lista (cdr lista))
              )
              (command "")
              (spstnc)
              (command "3dmesh" (/ nr 4) "4")
              (repeat nr (command (car listb))
                         (setq listb (cdr listb))
              )
              (command "")
              (spstnc)
       )
   )
   (setvar "osmode" zosm)
   (setvar "blipmode" zblp)
   (setvar "cmdecho" zcmd)
   (princ)
)
;
;--------------------------------------------------------------------
;Get the point with increment h in Z direction
;--------------------------------------------------------------------
(defun sp ( pt h)
   (list (car pt)(cadr pt)(+ (caddr pt) h))
)
;



